Index: /vtcross/trunk/src/libvtcross/libvtcross_demo.cpp
===================================================================
--- /vtcross/trunk/src/libvtcross/libvtcross_demo.cpp	(revision 239)
+++ /vtcross/trunk/src/libvtcross/libvtcross_demo.cpp	(revision 412)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/libvtcross/Makefile.am
===================================================================
--- /vtcross/trunk/src/libvtcross/Makefile.am	(revision 323)
+++ /vtcross/trunk/src/libvtcross/Makefile.am	(revision 412)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/libvtcross/swig/libvtcross.i
===================================================================
--- /vtcross/trunk/src/libvtcross/swig/libvtcross.i	(revision 299)
+++ /vtcross/trunk/src/libvtcross/swig/libvtcross.i	(revision 412)
@@ -1,2 +1,18 @@
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
+
 %module cross
 %{
Index: /vtcross/trunk/src/libvtcross/swig/__init__.py
===================================================================
--- /vtcross/trunk/src/libvtcross/swig/__init__.py	(revision 394)
+++ /vtcross/trunk/src/libvtcross/swig/__init__.py	(revision 412)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 from cross import *
 
Index: /vtcross/trunk/src/libvtcross/swig/Makefile.am
===================================================================
--- /vtcross/trunk/src/libvtcross/swig/Makefile.am	(revision 386)
+++ /vtcross/trunk/src/libvtcross/swig/Makefile.am	(revision 412)
@@ -1,2 +1,16 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
 include $(top_srcdir)/Makefile.common
 
Index: /vtcross/trunk/src/libvtcross/swig/libcross_demo.py
===================================================================
--- /vtcross/trunk/src/libvtcross/swig/libcross_demo.py	(revision 302)
+++ /vtcross/trunk/src/libvtcross/swig/libcross_demo.py	(revision 412)
@@ -1,2 +1,17 @@
+# Copyright 2009 Virginia Polytechnic Institute and State University  
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); 
+# you may not use this file except in compliance with the License. 
+# You may obtain a copy of the License at 
+# 
+# http://www.apache.org/licenses/LICENSE-2.0 
+#
+# Unless required by applicable law or agreed to in writing, software 
+# distributed under the License is distributed on an "AS IS" BASIS, 
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+# See the License for the specific language governing permissions and 
+# limitations under the License. 
+
+
 # Simple Python demonstration script for using
 # the CROSS system.
Index: /vtcross/trunk/src/libvtcross/libvtcross_demo_sml.cpp
===================================================================
--- /vtcross/trunk/src/libvtcross/libvtcross_demo_sml.cpp	(revision 285)
+++ /vtcross/trunk/src/libvtcross/libvtcross_demo_sml.cpp	(revision 412)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * TODO LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* TODO DESCRIPTION OF FILE.
Index: /vtcross/trunk/src/libvtcross/libvtcross.cpp
===================================================================
--- /vtcross/trunk/src/libvtcross/libvtcross.cpp	(revision 389)
+++ /vtcross/trunk/src/libvtcross/libvtcross.cpp	(revision 412)
@@ -1,7 +1,17 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
+/*
+ Copyright 2009 Virginia Polytechnic Institute and State University  
+
+ Licensed under the Apache License, Version 2.0 (the "License"); 
+ you may not use this file except in compliance with the License. 
+ You may obtain a copy of the License at 
+ 
+ http://www.apache.org/licenses/LICENSE-2.0 
+
+ Unless required by applicable law or agreed to in writing, software 
+ distributed under the License is distributed on an "AS IS" BASIS, 
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
+ See the License for the specific language governing permissions and 
+ limitations under the License. 
+*/
 
 /* Implementation file for the VCROSS Cognitive Radio public API defined in